//
//  RdioAppDelegate.m
//  Rdio
//
//  Created by Jonah Grant on 5/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RdioAppDelegate.h"
#import "RdioViewController.h"
#import "Settings.h"

@implementation RdioAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize rdio;

+ (Rdio *)rdioInstance {
	return [(RdioAppDelegate *)[[UIApplication sharedApplication] delegate] rdio];
}

#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
  
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];

	rdio = [[Rdio alloc] initWithConsumerKey:@"nkj3amh8v92c65hu58r386sm" andSecret:@"kzwyQjGKAc" delegate:nil];
	
	NSString *savedToken = [[Settings settings] accessToken];
	if (savedToken == nil) {
		[rdio authorizeFromController:self.viewController];
	}
	   
    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}

#pragma mark -
#pragma mark RdioDelegate

- (void)rdioDidAuthorizeUser:(NSDictionary *)user withAccessToken:(NSString *)accessToken {
	[super rdioDidAuthorizeUser:user withAccessToken:accessToken];
}

#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc {
    [viewController release];
	[rdio release];
    [window release];
    [super dealloc];
}


@end
